Index: /palm/trunk/SCRIPTS/inifor_script
===================================================================
--- /palm/trunk/SCRIPTS/inifor_script	(revision 3790)
+++ /palm/trunk/SCRIPTS/inifor_script	(revision 3791)
@@ -2035,871 +1148,471 @@
 EOF
 
-
-       # STARTING THE EXECUTABLE
-    printf "\n\n  *** execution starts in directory\n      \"`pwd`\"\n$dashes\n"
-    PATH=$PATH:$tempdir
-
-
-       # REPLACE PARAMETERS IN THE EXECUTION COMMAND WITH REAL VALUES
-    line=`echo  "${execute_command}" | sed 's/{{/$/g' | sed 's/}}//g'`
-    line2=`echo  "${execute_command}" | sed 's/{{mpi_tasks}}/1/g' | sed 's/{{tasks_per_node}}/1/g' | sed 's/palm/combine_plot_fields.x/g'`
-    eval line=\"$line\"
-    execute_command="$line"
-
-
-       # EXECUTION COMMAND FOR COMBINE_PLOT_FIELDS
-    if [[ "$execute_command_for_combine" = "" ]]
-    then
-       eval line2=\"$line2\"
-       execute_command_for_combine="$line2"
-    fi
-    
-
-
-       # PROVIDE A HOSTFILE, IF REQUIRED
-    if [[ "$hostfile" != "" ]]
-    then
-
-       if [[ $hostfile = auto ]]
-       then
-             # CREATE A NEW HOSTFILE
-          (( ii = 1 ))
-          while (( ii <= cores / threads_per_task ))
-          do
-             echo  $(hostname)  >>  hostfile
-             (( ii = ii + 1 ))
-          done
-          if (( cores / threads_per_task == 0 ))
-          then
-             echo  $(hostname)  >>  hostfile
-          fi
-       
+    # TODO: this is just an example for a possible access of the PALM parameters
+ grep -Eo '(\s*\&(initialization_parameters|inipar|runtime_parameters|d3par)\s*)|(([nd][xyz]|end_time|longitude|latitude|dz_stretch_level|dz_stretch_factor|dz_max)\s*\=\s*[0-9]*\.*\,*)|((dz_stretch_level_start|dz_stretch_level_end)\s*\=(\s*[0-9]*\.*\,*)*)|\/' PARIN
+
+    # COPY EXECUTABLE TO THIS TEMPORARY FOLDER
+ cp  ${base_directory}/MAKE_DEPOSITORY_${configuration_identifier}/inifor  .
+
+    # STARTING THE EXECUTABLE
+ printf "\n\n  *** inifor starts in directory\n      \"`pwd`\"\n$dashes\n"
+ PATH=$PATH:$tempdir
+
+
+    # REPLACE PARAMETERS IN THE EXECUTION COMMAND WITH REAL VALUES
+ line=`echo  "${execute_command_inifor}" | sed 's/{{/$/g' | sed 's/}}//g'`
+ eval line=\"$line\"
+ execute_command="$line"
+
+
+
+    # SET THE NUMBER OF OPENMP-THREADS
+ if [[ $use_openmp = true ]]
+ then
+    export OMP_NUM_THREADS=$threads_per_task
+    printf "\n  *** number of OpenMP threads per MPI-task: $OMP_NUM_THREADS"
+ else
+    export OMP_NUM_THREADS=1
+ fi
+
+
+ printf "\n  *** execute command:"
+ printf "\n      \"$execute_command\" \n\n"
+
+
+ $execute_command    &> >(tee STDOUT)
+ exit_code=${PIPESTATUS[0]}
+
+ if [[ ${exit_code} != 0 ]]
+ then
+
+        # ABORT IN CASE OF RUNTIME ERRORS
+    printf "\n  +++ runtime error occured"
+    locat=execution
+    exit
+
+ else
+
+    printf "\n$dashes\n  *** execution finished \n"
+
+ fi
+
+
+    # EXECUTE OUTPUT-COMMANDS GIVEN IN THE CONFIGURATION FILE
+ (( i = 0 ))
+ while (( i < ioc ))
+ do
+    (( i = i + 1 ))
+    if (( i == 1 ))
+    then
+       printf "\n\n  *** execution of OUTPUT-commands:\n$dashes"
+    fi
+
+       # REPLACE PARAMETERS IN THE OUTPUT COMMAND WITH REAL VALUES
+    out_command[$i]=`echo  "${out_command[$i]}" | sed 's/{{/$/g' | sed 's/}}//g'`
+
+    printf "\n  >>> ${out_command[$i]}"
+    eval  ${out_command[$i]}
+    if (( i == ioc ))
+    then
+       printf "\n$dashes\n"
+    fi
+ done
+
+
+    # IN A FIRST PASS, ADD ADDITIONAL OUTPUT FILE CONNECTIONS IN CASE OF
+    # WILDCARDS
+ (( i = 0 ))
+ (( nr_of_output_files = 0 ))
+
+ while (( i < iout ))
+ do
+
+    (( i = i + 1 ))
+
+       # FIRST CHECK FOR MULTIPLE NAMES WITH THE SAME LOCAL NAME AND
+       # CREATE A LIST FOR THE DETECTED ENDINGS
+    if [[ "${multout[$i]}" = true ]]
+    then
+          # DETERMINE THE EXISTING EXTENSIONS FROM THE LIST OF FILES
+       ls -1 -d ${localout_pre[$i]}    >   filelist  2>/dev/null
+       ls -1 -d ${localout_pre[$i]}_*  >>  filelist  2>/dev/null
+
+       endings="DEFAULT"
+       while  read line
+       do
+              # remove the local name from the beginning
+           localnamestring="${localout_pre[$i]}"
+           length_localname=${#localnamestring}
+           ending=${line:${length_localname}}
+
+           if [[ "$ending" != "" ]]
+           then
+              endings="$endings $ending"
+           fi
+ 
+       done <filelist
+
+       rm filelist
+
+    else
+
+          # SINGLE NAME
+       endings=DEFAULT
+
+    fi
+
+       # FOR EACH BASENAME ENDING CREATE AN ENTRY IN THE FINAL OUTPUT FILE LIST
+    for  ending  in  $endings
+    do
+
+          # DEFAULT MEANS THAT THE ENDING GIVEN IN .iofiles SHALL BE USED
+       if [[ $ending = DEFAULT ]]
+       then
+          ending=""
+       fi
+
+          # NEW ENTRY (ENDING IS ALSO ADDED TO LOCAL FILENAME READ BY PALM!)
+       (( nr_of_output_files = nr_of_output_files + 1 ))
+       localout[$nr_of_output_files]="${localout_pre[$i]}"$ending
+       transout[$nr_of_output_files]="${transout_pre[$i]}"
+       actionout[$nr_of_output_files]="${actionout_pre[$i]}"
+       pathout[$nr_of_output_files]="${pathout_pre[$i]}"
+       endout[$nr_of_output_files]="${endout_pre[$i]}"$ending
+       extout[$nr_of_output_files]="${extout_pre[$i]}"
+       warnout[$nr_of_output_files]="${warnout_pre[$i]}"
+
+    done
+
+ done
+
+
+    # COPY LOCAL OUTPUT-FILES TO THEIR PERMANENT DESTINATIONS
+ (( i = 0 ))
+ while (( i < nr_of_output_files ))
+ do
+    (( i = i + 1 ))
+    if (( i == 1 ))
+    then
+       printf "\n\n  *** saving OUTPUT-files:"
+
+          # GET RUN NUMBER ASSIGNED BY PALM
+       if [[ -f RUN_NUMBER ]]
+       then
+           read  run_number  <  RUN_NUMBER
+           printf "\n  *** PALM generated run_number = "$run_number" will be used as unified cycle number for all output files"
+           usecycle_option="-U $run_number"
        else
-          cp  $hostfile  hostfile
-       fi
-       eval line=\"`head -n $ii  hostfile`\"
-       printf "\n  *** running on: $line"
-    fi
-
-
-
-       # SET THE NUMBER OF OPENMP-THREADS
-    if [[ $use_openmp = true ]]
-    then
-       export OMP_NUM_THREADS=$threads_per_task
-       printf "\n  *** number of OpenMP threads per MPI-task: $OMP_NUM_THREADS"
+           run_number=0
+           usecycle_option=""
+       fi
+       if [[ $running_on_remote = true  &&  "$remote_loginnode" != "" ]]
+       then
+          printf "\n  *** in case of SCP transfers to local host"
+          printf "\n      they will be done via remote login-node \"$remote_loginnode\" "
+       fi
+       printf "\n$dashes"
+    fi
+
+    if [[ ! ( $running_on_remote = true  &&  ( "${actionout[$i]}" = tr || "${actionout[$i]}" = tra || "${actionout[$i]}" = trpe ) ) ]]
+    then
+
+       eval filename=${pathout[$i]}/${run_identifier}${endout[$i]}
+
+          # DETERMINE THE CYCLE NUMBER
+       ls -1 -d $filename    >   filelist  2>/dev/null
+       ls -1 -d $filename.*  >>  filelist  2>/dev/null
+       while  read line
+       do
+   
+             # filename without path (i.e. after the last "/")
+          basefilename=$(basename ${line})
+   
+             # check if there is an extension
+          extension=${basefilename##*.}
+          if [[ "$extension" = "${extout[$i]}" ]]
+          then
+             basefilename=${basefilename%.*}
+          fi
+   
+             # check for an existing cycle number
+          cycle=${basefilename##*.}
+          if [[ $cycle =~ ^-?[0-9]+$ ]]
+          then
+                # NUMBERS WITH LEADING ZEROS ARE INTERPRETED AS OCTAL NUMBERS
+                # 10# EXPLICITLY SPECIFIES THE NUMBER BASE AS 10
+             (( icycle = $((10#$cycle)) + 1 ))
+          else
+             (( icycle = 1 ))
+          fi
+   
+          if (( icycle > maxcycle ))
+          then
+             (( maxcycle = icycle ))
+          fi
+   
+       done <filelist
+       rm filelist
+
+   
+          # SET THE CYCLE NUMBER
+          # IN CASE OF FILE-APPEND, IT MUST BE THE HIGHEST EXISTING CYCLE NUMBER
+       if [[ "${actionout[$i]}" = a ]]
+       then
+          (( maxcycle = maxcycle - 1 ))
+       fi
+          
+       (( cycnum[$i] = maxcycle ))
+       pathout[$i]=$filename
+
+
+          # ADD CYCLE NUMBER TO FILENAME
+          # IN APPEND MODE, FILES KEEP THEIR CURRENT CYCLE NUMBER
+       if [[ "${actionout[$i]}" != "a" ]]
+       then
+             # SET RUN NUMBER AS CYCLE NUMBER, IF THERE IS NOT A CONFLICT
+             # WITH AN EXISTING CYCLE NUMBER
+          if (( run_number >= cycnum[$i] ))
+          then
+             (( cycnum[$i] = run_number ))
+          else
+             if (( run_number > 0 ))
+             then
+                printf "\n  --- INFORMATIVE: The following file cannot get a unified cycle number"
+             fi
+          fi
+       fi
+       if (( cycnum[$i] > 0 ))
+       then
+          cyclestring=`printf "%03d" ${cycnum[$i]}`
+          pathout[$i]=${pathout[$i]}.$cyclestring
+       fi
+    fi           
+
+       # CHECK FOR SINGLE FILE (SERIAL RUN) OR DIRECTORY (ONE FILE PER CORE FOR PARELLEL EXECUTION)
+    files_for_cores=false; filetype=file
+    link_local_output=false
+    if [[ "${actionout[$i]}" = pe  &&  -n $cores ]]
+    then
+       files_for_cores=true; filetype=directory
+       actionout[$i]=""
+    elif [[ "${actionout[$i]}" = pe  &&  ! -n $cores ]]
+    then
+       actionout[$i]=""
+    elif [[ "${actionout[$i]}" = lnpe  &&  -n $cores ]]
+    then
+       files_for_cores=true; filetype=directory
+       link_local_output=true
+       actionout[$i]=""
+    elif [[ "${actionout[$i]}" = lnpe  &&  ! -n $cores ]]
+    then
+       link_local_output
+       actionout[$i]=""
+    elif [[ "${actionout[$i]}" = trpe  &&  -n $cores ]]
+    then
+       files_for_cores=true; filetype=directory
+       actionout[$i]="tr"
+    elif [[ "${actionout[$i]}" = trpe  &&  ! -n $cores ]]
+    then
+       actionout[$i]="tr"
+    fi
+
+    if [[ ! -f ${localout[$i]}  &&  $files_for_cores = false ]]
+    then
+       if [[ ${warnout[$i]} = true ]]
+       then
+          printf "\n  +++ temporary OUTPUT-file  ${localout[$i]}  does not exist\n"
+       fi
+    elif [[ ! -d ${localout[$i]}  &&  $files_for_cores = true ]]
+    then
+       if [[ ${warnout[$i]} = true ]]
+       then
+          printf "\n  +++ temporary OUTPUT-file  ${localout[$i]}/....  does not exist\n"
+       fi
     else
-       export OMP_NUM_THREADS=1
-    fi
-
-
-       # PROVIDE DATA FOR ATMOSPHERE OCEAN COUPLING
-    if [[ $run_coupled_model = false ]]
-    then
-       if [[ "$ocean_file_appendix" = true ]]
-       then
-          echo "precursor_ocean"  >  coupling_steering
-       else
-          echo "precursor_atmos"  >  coupling_steering
-      fi
+
+
+          # COPY VIA SCP TO LOCAL HOST (ALWAYS IN BINARY MODE USING batch_scp option -m)
+          # IF TARGET DIRECTORY DOES NOT EXISTS, TRY TO CREATE IT
+       if [[ "${actionout[$i]}" = tr  ||  "${actionout[$i]}" = tra ]]
+       then
+          if [[ $running_on_remote = true ]]
+          then
+
+                # SET OPTIONS FOR TRANSFER
+             if [[ "${actionout[$i]}" = tr ]]
+             then
+                if [[ $files_for_cores = false ]]
+                then
+                   catalog_option=""
+                   catalog_string=""
+                else
+                   catalog_option="-c"
+                   catalog_string="/"
+                fi
+                append_option=""
+                append_string=""
+             else
+                append_option="-A"
+                append_string="append"
+             fi
+
+             transfer_failed=false
+             printf "\n  >>> OUTPUT: ${localout[$i]}$catalog_string  $append_string by SCP to"
+             printf "\n              ${pathout[$i]}/${configuration_identifier}_${run_identifier}${endout[$i]}$catalog_string\n"
+
+                # TRANSFER VIA SCP
+             if [[ "$remote_loginnode" != "" ]]
+             then
+                ssh -q $remote_username@$remote_loginnode  "cd $tempdir; ${fast_io_catalog}/${sources_for_run_catalog}/batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} \"${pathout[$i]}\" ${configuration_identifier}_${run_identifier}${endout[$i]}  ${extout[$i]}"
+             else
+                batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} "${pathout[$i]}" ${configuration_identifier}_${run_identifier}${endout[$i]}  ${extout[$i]}
+             fi
+             [[ ${PIPESTATUS[0]} != 0 ]]  &&  transfer_failed=true
+
+
+                # IF TRANSFER FAILED, CREATE BACKUP COPY ON THIS MACHINE
+             if [[ $transfer_failed = true ]]
+             then
+                printf "  +++ transfer failed. Trying to save a copy on this host under:\n"
+                printf "      ${pathout[$i]}/${configuration_identifier}_${run_identifier}${endout[$i]}_$run_id_number\n"
+
+                   # FIRST CHECK, IF DIRECTORY EXISTS, AND CREATE IT, IF NECESSARY
+                eval  local_catalog=${pathout[$i]}
+                if [[ ! -d $local_catalog ]]
+                then
+                   printf "  *** local directory does not exist. Trying to create:\n"
+                   printf "      $local_catalog \n"
+                   mkdir -p  $local_catalog
+                fi
+                eval  cp  ${localout[$i]}  ${pathout[$i]}/${configuration_identifier}_${run_identifier}${endout[$i]}_$run_id_number
+                transfer_problems=true
+             fi
+
+          else
+
+                # UNSET actionout. DUE TO THIS SETTING, FILE WILL LATER JUST
+                # BE COPIED OR APPENDED ON THIS MACHINE
+             if [[ "${actionout[$i]}" = tr ]]
+             then
+                actionout[$i]=""
+             else
+                actionout[$i]="a"
+             fi
+          fi
+       fi
+
+
+          # APPEND ON THIS MACHINE
+       if [[ "${actionout[$i]}" = "a" ]]
+       then
+          if [[ "${extout[$i]}" != " "  &&  "${extout[$i]}" != "" ]]
+          then
+             printf "\n  >>> OUTPUT: ${localout[$i]}  append to"
+             printf "\n              ${pathout[$i]}.${extout[$i]}\n"
+             cat  ${localout[$i]}  >>  ${pathout[$i]}.${extout[$i]}
+          else
+             printf "\n  >>> OUTPUT: ${localout[$i]}  append to"
+             printf "\n              ${pathout[$i]}\n"
+             cat  ${localout[$i]}  >>  ${pathout[$i]}
+          fi
+       fi
+
+          # COPY ON THIS MACHINE
+          # COPY HAS TO BE USED, BECAUSE MOVE DOES NOT WORK IF FILE-ORIGIN AND TARGET ARE
+          # ON DIFFERENT FILE-SYSTEMS
+       if [[ "${actionout[$i]}" = ""  &&  $files_for_cores = false ]]
+       then
+
+             # COPY IN CASE OF RUNS ON SINGLE CORES
+          if [[ "${extout[$i]}" != " "  &&  "${extout[$i]}" != "" ]]
+          then
+             printf "\n  >>> OUTPUT: ${localout[$i]}  to"
+             printf "\n              ${pathout[$i]}.${extout[$i]}\n"
+             if [[ $link_local_output = true ]]
+             then
+                printf "      file will be linked\n"
+                ln -f  ${localout[$i]}  ${pathout[$i]}.${extout[$i]}
+             fi
+                # If "ln -f" fails of if "$link_local_output = false" do a normal "cp"
+             if [[ ! -f "${pathout[$i]}.${extout[$i]}" ]]
+             then
+                if [[ $link_local_output = true ]]
+                then
+                   printf "  --- WARNING: ln failed, using cp instead (might be time consuming...)\n"
+                fi
+                cp  ${localout[$i]}  ${pathout[$i]}.${extout[$i]}
+             else
+                printf "+++ no copy because file ${pathout[$i]}.${extout[$i]} exists\n"
+             fi
+          else
+             printf "\n  >>> OUTPUT: ${localout[$i]}  to"
+             printf "\n              ${pathout[$i]}\n"
+             if [[ $link_local_output = true ]]
+             then
+                printf "      file will be linked\n"
+                ln -f  ${localout[$i]}  ${pathout[$i]}
+             fi
+                # If "ln -f" fails of if "$link_local_output = false" do a normal "cp"
+            	if [[ ! -f "${pathout[$i]}" ]]
+             then
+                if [[ $link_local_output = true ]]
+                then
+                   printf "  --- WARNING: ln failed, using cp instead (might be time consuming...)\n"
+                fi
+                cp  ${localout[$i]}  ${pathout[$i]}
+             else
+                printf "+++ no copy because file ${pathout[$i]} exists\n"
+             fi
+          fi
+
+       elif [[ "${actionout[$i]}" = ""  &&  $files_for_cores = true ]]
+       then
+
+             # FILES FROM THE DIFFERENT CORES ARE MOVED WITH ln-COMMAND TO THE PERMANENT DIRECTORY
+             # AS A FIRST STEP, THE PERMANENT DIRECTORY IS CREATED
+          printf "\n  >>> OUTPUT: ${localout[$i]}/_....  to"
+          printf "\n              ${pathout[$i]}\n"
+          if [[ $link_local_output = true ]]
+          then
+             printf "      files will be linked\n"
+             mkdir -p ${pathout[$i]}
+             cd ${localout[$i]}
+             for file in $(ls *)
+             do
+                ln -f $file  ${pathout[$i]}
+             done >|/dev/null 2>&1
+             cd $tempdir
+          fi
+
+             # IF "ln -f" HAS FAILED OR IF "$link_local_output = false" DO A NORMAL COPY "cp -r"
+          if [[ ! -f "${pathout[$i]}/_000000" ]]
+          then
+             if [[ $link_local_output = true ]]
+             then
+                printf "  --- WARNING: ln failed, using cp instead (might be time consuming...)\n"
+             fi
+             [[ ! -d "${pathout[$i]}" ]]  &&  mkdir  ${pathout[$i]}
+             cp -r  ${localout[$i]}/*  ${pathout[$i]}
+    	     fi
+
+       fi
+    fi
+ done
+
+ if (( i != 0 ))
+ then
+    if [[ $transfer_problems = true ]]
+    then
+       printf "\n$dashes\n  *** OUTPUT-files saved"
+       printf "\n  +++ WARNING: some data transfers failed! \n"
     else
-       (( iia = $cores_atmos / $threads_per_task ))
-       (( iio = $cores_ocean / $threads_per_task ))
-       printf "\n      coupled run ($iia atmosphere, $iio ocean)"
-       printf "\n\n"
-       echo "coupled_run $iia $iio"  >  coupling_steering
-    fi
-
-    printf "\n  *** execute command:"
-    printf "\n      \"$execute_command\" \n\n"
-
-
-    if [[ $progress_bar_disabled = true ]]
-    then
-       $execute_command  <  coupling_steering  &> >(grep -v --line-buffered -e '^STOP 1$' -e '^1$' &> >(tee STDOUT) )
-       exit_code=${PIPESTATUS[0]}
-    else
-       $execute_command  <  coupling_steering  &> >(tee STDOUT)
-       exit_code=${PIPESTATUS[0]}
-    fi
-
-    if [[ ${exit_code} != 0 ]]
-    then
-
-           # ABORT IN CASE OF RUNTIME ERRORS
-       printf "\n  +++ runtime error occured"
-       locat=execution
-       exit
-
-    else
-
-       printf "\n$dashes\n  *** execution finished \n"
-
-    fi
-
-
-       # CALL OF combine_plot_fields IN ORDER TO MERGE SINGLE FILES WRITTEN
-       # BY EACH CORE INTO ONE FILE
-   if [[ ! -f combine_plot_fields.x ]]
-   then
-
-      printf "\n\n\n  +++ WARNING: no combine_plot_fields found"
-      printf "\n      2d- and/or 3d-data may be incomplete!"
-      printf "\n      Your previous palmbuild may have failed. Please check.\n"
-
-   elif [[ "$combine_plot_fields" == true ]]
-   then
-
-      printf "\n\n\n *** post-processing: now executing \"$execute_command_for_combine\" ..."
-      $execute_command_for_combine
-
-   else
-
-         # TEMPORARY SOLUTION TO SKIP combine_plot_fields. THIS IS REQUIRED IN CASE OF HUGE AMOUNT OF
-         # DATA OUTPUT
-      printf "\n\n\n *** post-processing: skipping combine_plot_fields (-Z option set) ..."
-   fi
-
-
-
-       # EXECUTE OUTPUT-COMMANDS GIVEN IN THE CONFIGURATION FILE
-    (( i = 0 ))
-    while (( i < ioc ))
-    do
-       (( i = i + 1 ))
-       if (( i == 1 ))
-       then
-          printf "\n\n  *** execution of OUTPUT-commands:\n$dashes"
-       fi
-
-          # REPLACE PARAMETERS IN THE OUTPUT COMMAND WITH REAL VALUES
-       out_command[$i]=`echo  "${out_command[$i]}" | sed 's/{{/$/g' | sed 's/}}//g'`
-
-       printf "\n  >>> ${out_command[$i]}"
-       eval  ${out_command[$i]}
-       if (( i == ioc ))
-       then
-          printf "\n$dashes\n"
-       fi
-    done
-
-
-       # IN A FIRST PASS, ADD ADDITIONAL OUTPUT FILE CONNECTIONS IN CASE OF
-       # WILDCARDS
-    (( i = 0 ))
-    (( nr_of_output_files = 0 ))
-
-    while (( i < iout ))
-    do
-
-       (( i = i + 1 ))
-
-          # FIRST CHECK FOR MULTIPLE NAMES WITH THE SAME LOCAL NAME AND
-          # CREATE A LIST FOR THE DETECTED ENDINGS
-       if [[ "${multout[$i]}" = true ]]
-       then
-             # DETERMINE THE EXISTING EXTENSIONS FROM THE LIST OF FILES
-          ls -1 -d ${localout_pre[$i]}    >   filelist  2>/dev/null
-          ls -1 -d ${localout_pre[$i]}_*  >>  filelist  2>/dev/null
-
-          endings="DEFAULT"
-          while  read line
-          do
-                 # remove the local name from the beginning
-              localnamestring="${localout_pre[$i]}"
-              length_localname=${#localnamestring}
-              ending=${line:${length_localname}}
-
-              if [[ "$ending" != "" ]]
-              then
-                 endings="$endings $ending"
-              fi
- 
-          done <filelist
-
-          rm filelist
-
-       else
-
-             # SINGLE NAME
-          endings=DEFAULT
-
-       fi
-
-          # FOR EACH BASENAME ENDING CREATE AN ENTRY IN THE FINAL OUTPUT FILE LIST
-       for  ending  in  $endings
-       do
-
-             # DEFAULT MEANS THAT THE ENDING GIVEN IN .iofiles SHALL BE USED
-          if [[ $ending = DEFAULT ]]
-          then
-             ending=""
-          fi
-
-             # NEW ENTRY (ENDING IS ALSO ADDED TO LOCAL FILENAME READ BY PALM!)
-          (( nr_of_output_files = nr_of_output_files + 1 ))
-          localout[$nr_of_output_files]="${localout_pre[$i]}"$ending
-          transout[$nr_of_output_files]="${transout_pre[$i]}"
-          actionout[$nr_of_output_files]="${actionout_pre[$i]}"
-          pathout[$nr_of_output_files]="${pathout_pre[$i]}"
-          endout[$nr_of_output_files]="${endout_pre[$i]}"$ending
-          extout[$nr_of_output_files]="${extout_pre[$i]}"
-          warnout[$nr_of_output_files]="${warnout_pre[$i]}"
-
-       done
-
-    done
-
-
-
-
-       # COPY LOCAL OUTPUT-FILES TO THEIR PERMANENT DESTINATIONS
-    (( i = 0 ))
-    while (( i < nr_of_output_files ))
-    do
-       (( i = i + 1 ))
-       if (( i == 1 ))
-       then
-          printf "\n\n  *** saving OUTPUT-files:"
-
-             # GET RUN NUMBER ASSIGNED BY PALM
-          if [[ -f RUN_NUMBER ]]
-          then
-              read  run_number  <  RUN_NUMBER
-              printf "\n  *** PALM generated run_number = "$run_number" will be used as unified cycle number for all output files"
-              usecycle_option="-U $run_number"
-          else
-              run_number=0
-              usecycle_option=""
-          fi
-          if [[ $running_on_remote = true  &&  "$remote_loginnode" != "" ]]
-          then
-             printf "\n  *** in case of SCP transfers to local host"
-             printf "\n      they will be done via remote login-node \"$remote_loginnode\" "
-          fi
-          printf "\n$dashes"
-       fi
-
-       if [[ ! ( $running_on_remote = true  &&  ( "${actionout[$i]}" = tr || "${actionout[$i]}" = tra || "${actionout[$i]}" = trpe ) ) ]]
-       then
-
-          eval filename=${pathout[$i]}/${run_identifier}${endout[$i]}
-
-             # DETERMINE THE CYCLE NUMBER
-          ls -1 -d $filename    >   filelist  2>/dev/null
-          ls -1 -d $filename.*  >>  filelist  2>/dev/null
-          while  read line
-          do
-   
-                # filename without path (i.e. after the last "/")
-             basefilename=$(basename ${line})
-   
-                # check if there is an extension
-             extension=${basefilename##*.}
-             if [[ "$extension" = "${extout[$i]}" ]]
-             then
-                basefilename=${basefilename%.*}
-             fi
-   
-                # check for an existing cycle number
-             cycle=${basefilename##*.}
-             if [[ $cycle =~ ^-?[0-9]+$ ]]
-             then
-                   # NUMBERS WITH LEADING ZEROS ARE INTERPRETED AS OCTAL NUMBERS
-                   # 10# EXPLICITLY SPECIFIES THE NUMBER BASE AS 10
-                (( icycle = $((10#$cycle)) + 1 ))
-             else
-                (( icycle = 1 ))
-             fi
-   
-             if (( icycle > maxcycle ))
-             then
-                (( maxcycle = icycle ))
-             fi
-   
-          done <filelist
-          rm filelist
-
-   
-             # SET THE CYCLE NUMBER
-             # IN CASE OF FILE-APPEND, IT MUST BE THE HIGHEST EXISTING CYCLE NUMBER
-          if [[ "${actionout[$i]}" = a ]]
-          then
-             (( maxcycle = maxcycle - 1 ))
-          fi
-          
-          (( cycnum[$i] = maxcycle ))
-          pathout[$i]=$filename
-
-
-             # ADD CYCLE NUMBER TO FILENAME
-             # IN APPEND MODE, FILES KEEP THEIR CURRENT CYCLE NUMBER
-          if [[ "${actionout[$i]}" != "a" ]]
-          then
-                # SET RUN NUMBER AS CYCLE NUMBER, IF THERE IS NOT A CONFLICT
-                # WITH AN EXISTING CYCLE NUMBER
-             if (( run_number >= cycnum[$i] ))
-             then
-                (( cycnum[$i] = run_number ))
-             else
-                if (( run_number > 0 ))
-                then
-                   printf "\n  --- INFORMATIVE: The following file cannot get a unified cycle number"
-                fi
-             fi
-          fi
-          if (( cycnum[$i] > 0 ))
-          then
-             cyclestring=`printf "%03d" ${cycnum[$i]}`
-             pathout[$i]=${pathout[$i]}.$cyclestring
-          fi
-       fi           
-
-          # CHECK FOR SINGLE FILE (SERIAL RUN) OR DIRECTORY (ONE FILE PER CORE FOR PARELLEL EXECUTION)
-       files_for_cores=false; filetype=file
-       link_local_output=false
-       if [[ "${actionout[$i]}" = pe  &&  -n $cores ]]
-       then
-          files_for_cores=true; filetype=directory
-          actionout[$i]=""
-       elif [[ "${actionout[$i]}" = pe  &&  ! -n $cores ]]
-       then
-          actionout[$i]=""
-       elif [[ "${actionout[$i]}" = lnpe  &&  -n $cores ]]
-       then
-          files_for_cores=true; filetype=directory
-          link_local_output=true
-          actionout[$i]=""
-       elif [[ "${actionout[$i]}" = lnpe  &&  ! -n $cores ]]
-       then
-          link_local_output
-          actionout[$i]=""
-       elif [[ "${actionout[$i]}" = trpe  &&  -n $cores ]]
-       then
-          files_for_cores=true; filetype=directory
-          actionout[$i]="tr"
-       elif [[ "${actionout[$i]}" = trpe  &&  ! -n $cores ]]
-       then
-          actionout[$i]="tr"
-       fi
-
-       if [[ ! -f ${localout[$i]}  &&  $files_for_cores = false ]]
-       then
-          if [[ ${warnout[$i]} = true ]]
-          then
-             printf "\n  +++ temporary OUTPUT-file  ${localout[$i]}  does not exist\n"
-          fi
-       elif [[ ! -d ${localout[$i]}  &&  $files_for_cores = true ]]
-       then
-          if [[ ${warnout[$i]} = true ]]
-          then
-             printf "\n  +++ temporary OUTPUT-file  ${localout[$i]}/....  does not exist\n"
-          fi
-       else
-
-
-             # COPY VIA SCP TO LOCAL HOST (ALWAYS IN BINARY MODE USING batch_scp option -m)
-             # IF TARGET DIRECTORY DOES NOT EXISTS, TRY TO CREATE IT
-          if [[ "${actionout[$i]}" = tr  ||  "${actionout[$i]}" = tra ]]
-          then
-             if [[ $running_on_remote = true ]]
-             then
-
-                   # SET OPTIONS FOR TRANSFER
-                if [[ "${actionout[$i]}" = tr ]]
-                then
-                   if [[ $files_for_cores = false ]]
-                   then
-                      catalog_option=""
-                      catalog_string=""
-                   else
-                      catalog_option="-c"
-                      catalog_string="/"
-                   fi
-                   append_option=""
-                   append_string=""
-                else
-                   append_option="-A"
-                   append_string="append"
-                fi
-
-                transfer_failed=false
-                printf "\n  >>> OUTPUT: ${localout[$i]}$catalog_string  $append_string by SCP to"
-                printf "\n              ${pathout[$i]}/${configuration_identifier}_${run_identifier}${endout[$i]}$catalog_string\n"
-
-                   # TRANSFER VIA SCP
-                if [[ "$remote_loginnode" != "" ]]
-                then
-                   ssh -q $remote_username@$remote_loginnode  "cd $tempdir; ${fast_io_catalog}/${sources_for_run_catalog}/batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} \"${pathout[$i]}\" ${configuration_identifier}_${run_identifier}${endout[$i]}  ${extout[$i]}"
-                else
-                   batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} "${pathout[$i]}" ${configuration_identifier}_${run_identifier}${endout[$i]}  ${extout[$i]}
-                fi
-                [[ ${PIPESTATUS[0]} != 0 ]]  &&  transfer_failed=true
-
-
-                   # IF TRANSFER FAILED, CREATE BACKUP COPY ON THIS MACHINE
-                if [[ $transfer_failed = true ]]
-                then
-                   printf "  +++ transfer failed. Trying to save a copy on this host under:\n"
-                   printf "      ${pathout[$i]}/${configuration_identifier}_${run_identifier}${endout[$i]}_$run_id_number\n"
-
-                      # FIRST CHECK, IF DIRECTORY EXISTS, AND CREATE IT, IF NECESSARY
-                   eval  local_catalog=${pathout[$i]}
-                   if [[ ! -d $local_catalog ]]
-                   then
-                      printf "  *** local directory does not exist. Trying to create:\n"
-                      printf "      $local_catalog \n"
-                      mkdir -p  $local_catalog
-                   fi
-                   eval  cp  ${localout[$i]}  ${pathout[$i]}/${configuration_identifier}_${run_identifier}${endout[$i]}_$run_id_number
-                   transfer_problems=true
-                fi
-
-             else
-
-                   # UNSET actionout. DUE TO THIS SETTING, FILE WILL LATER JUST
-                   # BE COPIED OR APPENDED ON THIS MACHINE
-                if [[ "${actionout[$i]}" = tr ]]
-                then
-                   actionout[$i]=""
-                else
-                   actionout[$i]="a"
-                fi
-             fi
-          fi
-
-
-             # APPEND ON THIS MACHINE
-          if [[ "${actionout[$i]}" = "a" ]]
-          then
-             if [[ "${extout[$i]}" != " "  &&  "${extout[$i]}" != "" ]]
-             then
-                printf "\n  >>> OUTPUT: ${localout[$i]}  append to"
-                printf "\n              ${pathout[$i]}.${extout[$i]}\n"
-                cat  ${localout[$i]}  >>  ${pathout[$i]}.${extout[$i]}
-             else
-                printf "\n  >>> OUTPUT: ${localout[$i]}  append to"
-                printf "\n              ${pathout[$i]}\n"
-                cat  ${localout[$i]}  >>  ${pathout[$i]}
-             fi
-          fi
-
-             # COPY ON THIS MACHINE
-             # COPY HAS TO BE USED, BECAUSE MOVE DOES NOT WORK IF FILE-ORIGIN AND TARGET ARE
-             # ON DIFFERENT FILE-SYSTEMS
-          if [[ "${actionout[$i]}" = ""  &&  $files_for_cores = false ]]
-          then
-
-                # COPY IN CASE OF RUNS ON SINGLE CORES
-             if [[ "${extout[$i]}" != " "  &&  "${extout[$i]}" != "" ]]
-             then
-                printf "\n  >>> OUTPUT: ${localout[$i]}  to"
-                printf "\n              ${pathout[$i]}.${extout[$i]}\n"
-		              if [[ $link_local_output = true ]]
-		              then
-		                 printf "      file will be linked\n"
-		                 ln -f  ${localout[$i]}  ${pathout[$i]}.${extout[$i]}
-		              fi
-		                 # If "ln -f" fails of if "$link_local_output = false" do a normal "cp"
-		              if [[ ! -f "${pathout[$i]}.${extout[$i]}" ]]
-                then
-		                 if [[ $link_local_output = true ]]
-	                  then
-                      printf "  --- WARNING: ln failed, using cp instead (might be time consuming...)\n"
-		                 fi
-		                 cp  ${localout[$i]}  ${pathout[$i]}.${extout[$i]}
-		              else
-                   printf "+++ no copy because file ${pathout[$i]}.${extout[$i]} exists\n"
-                fi
-             else
-                printf "\n  >>> OUTPUT: ${localout[$i]}  to"
-                printf "\n              ${pathout[$i]}\n"
-		              if [[ $link_local_output = true ]]
-		              then
-		                 printf "      file will be linked\n"
-		                 ln -f  ${localout[$i]}  ${pathout[$i]}
-		              fi
-		                 # If "ln -f" fails of if "$link_local_output = false" do a normal "cp"
-	              	if [[ ! -f "${pathout[$i]}" ]]
-                then
-		                 if [[ $link_local_output = true ]]
-	                  then
-                      printf "  --- WARNING: ln failed, using cp instead (might be time consuming...)\n"
-		                 fi
-		                 cp  ${localout[$i]}  ${pathout[$i]}
-		              else
-		                 printf "+++ no copy because file ${pathout[$i]} exists\n"
-                fi
-             fi
-
-          elif [[ "${actionout[$i]}" = ""  &&  $files_for_cores = true ]]
-          then
-
-                # FILES FROM THE DIFFERENT CORES ARE MOVED WITH ln-COMMAND TO THE PERMANENT DIRECTORY
-                # AS A FIRST STEP, THE PERMANENT DIRECTORY IS CREATED
-             printf "\n  >>> OUTPUT: ${localout[$i]}/_....  to"
-             printf "\n              ${pathout[$i]}\n"
-	            if [[ $link_local_output = true ]]
-	            then
-		              printf "      files will be linked\n"
-		              mkdir -p ${pathout[$i]}
-		              cd ${localout[$i]}
-		              for file in $(ls *)
-		              do
-		                 ln -f $file  ${pathout[$i]}
-		              done >|/dev/null 2>&1
-		              cd $tempdir
-	            fi
-
-                # IF "ln -f" HAS FAILED OR IF "$link_local_output = false" DO A NORMAL COPY "cp -r"
-	            if [[ ! -f "${pathout[$i]}/_000000" ]]
-             then
-		              if [[ $link_local_output = true ]]
-		              then
-                   printf "  --- WARNING: ln failed, using cp instead (might be time consuming...)\n"
-		              fi
-		              [[ ! -d "${pathout[$i]}" ]]  &&  mkdir  ${pathout[$i]}
-		              cp -r  ${localout[$i]}/*  ${pathout[$i]}
-       	     fi
-
-          fi
-       fi
-    done
-
-    if (( i != 0 ))
-    then
-       if [[ $transfer_problems = true ]]
-       then
-          printf "\n$dashes\n  *** OUTPUT-files saved"
-          printf "\n  +++ WARNING: some data transfers failed! \n"
-       else
-          printf "\n$dashes\n  *** all OUTPUT-files saved \n"
-       fi
-    fi
-
-
-       # IF REQUIRED, START A RESTART-JOB
-       # FILE CONTINUE_RUN MUST HAVE BEEN CREATED BY THE EXECUTABLE (PALM)
-    if [[ -f CONTINUE_RUN ]]
-    then
-
-          # ADD RESTART-OPTIONS TO THE PALMRUN-CALL (IF THEY ARE NOT USED ALREADY):
-          # -C TELLS PALMRUN THAT IT IS A RESTART-RUN
-          # -v SILENT MODE WITHOUT INTERACTIVE QUERIES
-          # -b START A BATCH JOB
-       [[ $(echo $prc | grep -c "\-C") = 0 ]]  &&  prc="$prc -C"
-       [[ $(echo $prc | grep -c "\-v") = 0 ]]  &&  prc="$prc -v"
-       [[ $(echo $prc | grep -c "\-b") = 0 ]]  &&  prc="$prc -b"
-
-          # REPLACE SVFOUT IN THE ACTIVATION STRINGS (GIVEN WITH OPTION -a)
-          # SO THAT RESTARTS USE SVF DATA CREATED BY THE INITIAL RUN
-       if [[ $(echo $prc | grep -c "svfout") != 0 ]]
-       then
-          prc=`echo $prc | sed 's/svfout/svfin/g'`
-       fi
-
-          # REPLACE THE HASH IN THE ACTIVATION STRINGS (GIVEN WITH OPTION -a)
-          # SO THAT RESTARTS ACCESS DIFFERENT FILES THAN THE INITIAL RUN
-       if [[ $(echo $prc | grep -c "#") != 0 ]]
-       then
-          prc=`echo $prc | sed 's/#/r/g'`
-       fi
-
-
-          # START THE RESTART-JOB
-       printf "\n\n  *** initiating restart-run on \"$local_ip\" using command:\n"
-       echo "      $prc"
-       printf "\n$dashes\n"
-       if [[ $running_on_remote = true ]]
-       then
-
-          echo "*** ssh will be used to initiate restart-runs!"
-          echo "    return_address=\"$return_address\" "
-          echo "    return_username=\"$local_username\" "
-
-          if [[ "$remote_loginnode" != "" ]]
-          then
-             ssh -q $remote_username@$remote_loginnode  "ssh -q $SSH_PORTOPT  $local_username@$return_address \" PATH=\\\$PATH:$LOCAL_PALMRUN_PATH; cd $LOCAL_PWD; $prc\" " |  tee palmrun_restart.log
-          else
-             ssh -q $SSH_PORTOPT  $local_username@$return_address  " PATH=\\\$PATH:$LOCAL_PALMRUN_PATH; cd $LOCAL_PWD; $prc" |  tee palmrun_restart.log
-          fi
-
-             # WAIT TO ALLOW THE RESTART-JOB TO BE QUEUED, BEFORE THE CURRENT JOB IS FINISHED
-          sleep 30
-
-       else
-
-             # START THE RESTART JOB ON THE LOCAL HOST
-          eval  $prc  |  tee palmrun_restart.log              # THE ' MUST BE EVALUATED
-
-       fi
-
-          # CHECK, IF RESTART JOB HAS BEEN STARTED
-       if [[ $( grep -c "+++ palmrun crashed"  palmrun_restart.log ) != 0 ]]
-       then
-          printf "\n$dashes\n  +++ creating restart run failed \n"
-          locat=create_restart
-          rm  palmrun_restart.log
-          exit
-       elif [[ $( grep -c "*** palmrun finished"  palmrun_restart.log ) != 1 ]]
-       then
-          printf "\n$dashes\n  +++ creating restart run failed, probably due to network problems\n"
-          locat=create_restart
-          rm  palmrun_restart.log
-          exit       
-       else
-          printf "\n$dashes\n  *** restart run initiated \n"
-          rm  palmrun_restart.log
-       fi
-
-
-          # DELETE INPUT-(RESTART)FILES, WHICH HAVE BEEN FETCHED FROM THE TEMPORARY DATA
-          # DIRECTORY, BACAUSE THEY ARE NOT REQUIRED BY THE RESTART-JOB.
-          # THIS IS DONE IN ORDER TO AVOID EXCEEDING DISC QUOTAS OR DISC SPACE (RESTART-FILES
-          # MAY BE VERY HUGE)
-       (( i = 0 ))
-       while (( i < nr_of_input_files ))
-       do
-          (( i = i + 1 ))
-          if [[ "${got_tmp[$i]}" = true   &&  $keep_data_from_previous_run = false ]]
-          then
-             rm -r  ${absnamein[$i]}
-          fi
-       done
-
-    fi
-
-
-       # ALL ACTIONS FINISHED, TEMPORARY WORKING-DIRECTORY CAN BE DELETED
-    cd  $HOME
-    [[ $delete_temporary_catalog = true ]]  &&  rm -rf $tempdir
-
-
- else
-
-
-       # PREPARING ACTIONS,
-       # IF A BATCH-JOB IS TO BE GENERATED AND TO BE STARTED ON A LOCAL OR REMOTE-MACHINE
-
-       # BUILD THE PALMRUN-COMMAND TO BE CALLED IN THE BATCH-JOB
-    palmrun_com="$palmrun_script_name -r $run_identifier -c $configuration_identifier -m $memory -t $cpumax -q $queue -i $run_id_number -U $local_username"
-    [[ "$activation_string_list" != "" ]]  &&  palmrun_com=${palmrun_com}" -a \"$activation_string_list\""
-    [[ "$global_revision" != "" ]]  &&  palmrun_com=${palmrun_com}" -G \"$global_revision\""
-    [[ $keep_data_from_previous_run = true ]]  &&  palmrun_com=${palmrun_com}" -k"
-    [[ $do_trace = true ]]        &&  palmrun_com=${palmrun_com}" -x"
-    [[ "$cores" != "" ]]       &&  palmrun_com=${palmrun_com}" -X $cores"
-    [[ $use_openmp = true ]]  &&  palmrun_com=${palmrun_com}" -O $threads_per_task"
-    [[ $tasks_per_node != 0 ]]  &&  palmrun_com=${palmrun_com}" -T $tasks_per_node"
-    [[ $delete_temporary_catalog = false ]]  &&  palmrun_com=${palmrun_com}" -B"
-    [[ "$ocean_file_appendix" = true ]]  &&  palmrun_com=${palmrun_com}" -y"
-    [[ $run_coupled_model = true ]]  &&  palmrun_com=${palmrun_com}" -Y \"$coupled_dist\""
-    [[ "$combine_plot_fields" = false ]]  &&  palmrun_com=${palmrun_com}" -Z"
-    [[ "$max_par_io_str" != "" ]]  &&  palmrun_com=${palmrun_com}" -w $max_par_io_str"
-    [[ "$project_account" != "" ]]  &&  palmrun_com=${palmrun_com}" -A $project_account"
-    if [[ $create_remote_batch_job = true ]]
-    then
-       palmrun_com=${palmrun_com}" -j -u $remote_username -R $local_ip"
-       if [[ $do_trace = true ]]
-       then
-          printf "\n *** PALMRUN-command on remote host:\n     $palmrun_com \n"
-       fi
-    elif [[ $create_batch_job = true ]]
-    then
-       palmrun_com=${palmrun_com}" -j"
-       if [[ $do_trace = true ]]
-       then
-          printf "\n *** PALMRUN-command on local host:\n     $palmrun_com \n"
-       fi
-    fi
-
-
-       # DETERMINE THE FULL PATHS FOR THE JOB PROTOCOL FILES ON THE LOCAL AND
-       # REMOTE HOST
-    job_protocol_file_local=${local_jobcatalog}/${configuration_identifier}_${run_id}
-    job_protocol_file=$job_protocol_file_local
-    if [[ $create_remote_batch_job = true ]]
-    then
-       job_protocol_file_remote=${remote_jobcatalog}/${configuration_identifier}_${run_id}
-       job_protocol_file=$job_protocol_file_remote
-       job_transfer_protocol_file=${remote_jobcatalog}/last_job_transfer_protocol
-       scpjob_file=${remote_jobcatalog}/scpjob.$run_id_number
-    fi
-
-
-       # BUILD THE JOB-SCRIPTS ON FILE jobfile
-    jobfile=jobfile.$run_id_number
-
-
-       # FIRST CREATE THE BATCH DIRECTIVES
-    (( i = 0 ))
-    while (( i < ibd ))
-    do
-       (( i = i + 1 ))
-       line=`echo  "${batch_directive[$i]}" | sed 's/{{/$/g' | sed 's/}}//g'`
-       eval line=\"$line\"
-       echo  "$line"                               >>  $jobfile
-    done
-    echo " "                                       >>  $jobfile
-
-
-       # FOR BATCH JOBS ON REMOTE HOSTS, ADD THE JOBFILE TO SEND BACK THE JOB
-       # PROTOCOL
-    if [[ $create_remote_batch_job = true ]]
-    then
-       echo "set +vx"                                   >>  $jobfile
-       echo "trap '"                                    >>  $jobfile
-       echo "set +vx"                                   >>  $jobfile
-       echo "cd ${remote_jobcatalog}"                   >>  $jobfile
-       echo "cat >  scpjob.$run_id_number << %%END%%"   >>  $jobfile
-
-          # ADD THE BATCH DIRECTIVES
-       (( i = 0 ))
-       while (( i < ibdt ))
-       do
-          (( i = i + 1 ))
-          line=`echo  "${batch_directive_transfer[$i]}" | sed 's/{{/$/g' | sed 's/}}//g'`
-          eval line=\"$line\"
-          echo  "$line"                            >>  $jobfile
-       done
-       echo " "                                    >>  $jobfile
-
-       echo "set -x"                               >>  $jobfile
-       if [[ "$remote_loginnode" != "" ]]
-       then
-          echo "ssh -q $remote_username@$remote_loginnode  \"cd ${remote_jobcatalog}; ${fast_io_catalog}/${sources_for_run_catalog}/batch_scp  $PORTOPT  -d  -w 10  -u $local_username $local_ip  $job_protocol_file_remote \\\"$local_jobcatalog\\\"  ${configuration_identifier}_${run_identifier}\" "  >> $jobfile
-       else
-          echo "${fast_io_catalog}/${sources_for_run_catalog}/batch_scp  $PORTOPT  -d  -w 10  -u $local_username $local_ip  $job_protocol_file_remote  \"$local_jobcatalog\"  ${configuration_identifier}_${run_identifier}"  >>  $jobfile
-       fi
-       echo "%%END%%"                              >>  $jobfile
-       echo "echo \" *** submitting job for transfering the job protocol file to $local_ip\" "  >>  $jobfile
-       echo "$submit_command  $scpjob_file"     >>  $jobfile
-       echo "rm $scpjob_file"                      >>  $jobfile
-       echo "rm -rf $job_transfer_protocol_file"   >>  $jobfile
-       echo "set -x"                               >>  $jobfile
-       echo "     ' exit"                          >>  $jobfile
-    fi
-
-
-       # ACTIVATE ERROR-TRACEBACK
-    if [[ $do_trace = true ]]
-    then
-       echo  "set -x"                                    >>  $jobfile
-    else
-       echo  "set +vx"                                   >>  $jobfile
-    fi
-
-
-       # INITIALIZE THE ENVIRONMENT AND LOAD MODULES
-    if [[ "$login_init_cmd" != "" ]]
-    then
-       echo  "$login_init_cmd"        >>  $jobfile
-    fi
-    if [[ "$module_commands" != "" ]]
-    then
-       echo  "$module_commands"     >>  $jobfile
-    fi
-
-
-       # CREATE TEMPORARY DIRECTORY AND SWITCH TO IT
-    if [[ $create_remote_batch_job = true ]]
-    then
-       echo  "mkdir  $tempdir"           >>  $jobfile
-       echo  "chmod  go+rx  $tempdir"    >>  $jobfile
-    else
-          # DIRECTORY FOR LOCAL BATCH JOBS IS CREATED NOW, DUE TO A
-          # REQUIREMENT OF THE GRID ENGINE BATCH SYSTEM (WORKING DIR IS GIVEN IN
-          # BATCH DIRECTIVE -wd AND MUST ALREADY EXIST WHEN THE JOB IS SUBMITTED)
-       mkdir  $tempdir
-       chmod  go+rx  $tempdir
-    fi
-    echo  "cd  $tempdir"                 >>  $jobfile
-    echo  "export tempdir=$tempdir"      >>  $jobfile
-    echo  "cp  ${fast_io_catalog}/${sources_for_run_catalog}/{*,.[!.]*}  ."  >>  $jobfile
-    echo  "export PATH=.:\$PATH"         >>  $jobfile
-    echo  "export execute_palmrun=true"  >>  $jobfile
-
-
-       # PROVIDE NAME OF THE CURRENT WORKING-DIRECTORY ON THE LOCAL MACHINE (FROM WHERE THE JOB IS
-       # STARTED) BY SETTING AN ENVIRONMENT-VARIABLE. THIS INFORMATION IS USED IN THE JOB BY PALMRUN
-       # IN CASE THAT RESTART-RUNS HAVE TO BE GENERATED
-    echo  "LOCAL_PWD=$working_directory"                >>  $jobfile
-    echo  "export LOCAL_PWD"                            >>  $jobfile
-
-
-       # PROVIDE THE PATH OF THE LOCAL PALMRUN-SCRIPT FOR THE SAME REASON 
-    echo  "LOCAL_PALMRUN_PATH=${source_path}/../SCRIPTS"   >>  $jobfile
-    echo  "export LOCAL_PALMRUN_PATH"                      >>  $jobfile
-
-
-       # CALL PALMRUN WITHIN THE JOB
-       # AS FINAL ACTION, REMOVE THE TEMPORARY DIRECTORY CREATED AT THE BEGINNING OF THE JOB
-    echo  "set -x"                                              >>  $jobfile
-    echo  "[[ \$execute_palmrun = true ]]  &&  $palmrun_com"    >>  $jobfile
-
-
-       # TRANSFER JOBFILE TO THE TARGET HOST
-    if [[ $create_jobfile_only = false ]]
-    then
-
-          # CREATE LOCAL JOB FOLDER
-       eval  local_jobcatalog=$local_jobcatalog
-       if [[ ! -d $local_jobcatalog ]]
-       then
-          echo " "
-          echo " *** local jobcatalog \"$local_jobcatalog\" does not exist and will be created now"
-          mkdir  $local_jobcatalog
-       fi
- 
-       if [[ $create_remote_batch_job = true ]]
-       then
-
-          echo " "
-          echo " *** transfer of job to remote host via scp"
-
-             # CREATE REMOTE JOB FOLDER, IF IT DOES NOT EXIST
-          ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip}  "[[ ! -d $remote_jobcatalog ]]  &&  mkdir $remote_jobcatalog"  2>&1
-
-             # COPY THE JOB FILE 
-          if [[ $do_trace = true ]]
-          then
-             echo "     scp $ssh_key $PORTOPT $jobfile ${remote_username}@${remote_ip}:${remote_jobcatalog}/${configuration_identifier}_${run_id}"
-          fi
-          scp $ssh_key $PORTOPT $jobfile ${remote_username}@${remote_ip}:${remote_jobcatalog}/${configuration_identifier}_${run_id}  >  /dev/null
-
-             # SUBMIT THE JOB
-          printf " *** submit the job (output of submit command, \n"
-          printf "     e.g. the job-id given by the batch-system, may follow) \n"
-          if [[ $do_trace = true ]]
-          then
-             echo "     ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip} \"cd $remote_jobcatalog; $submit_command ${configuration_identifier}_${run_id}; rm ${configuration_identifier}_${run_id}\" "
-          fi
-          ssh  -q  $ssh_key $SSH_PORTOPT  ${remote_username}@${remote_ip} "cd $remote_jobcatalog; $submit_command ${configuration_identifier}_${run_id}; rm ${configuration_identifier}_${run_id}"
-
-       elif [[ $create_batch_job = true ]]
-       then
-
-          eval  local_jobcatalog=$local_jobcatalog
-          cp  $jobfile  ${local_jobcatalog}/${configuration_identifier}_${run_id}
-          cd $local_jobcatalog
-          echo " "
-          echo " *** submit the job"
-          if [[ $do_trace = true ]]
-          then
-             echo "$submit_command ${configuration_identifier}_${run_id}"
-          fi
-          $submit_command ${configuration_identifier}_${run_id}
-          rm ${configuration_identifier}_${run_id}
-          cd -  > /dev/null
-
-       fi
-
-       rm -rf  $jobfile
-
-    else
-
-       printf "\n *** jobfile created under name \"$jobfile\" "
-       printf "\n     no batch-job has been sent!"
-
-    fi
-
- fi  # END OF REMOTE-PART
+       printf "\n$dashes\n  *** all OUTPUT-files saved \n"
+    fi
+ fi
+
+
+
+
+    # ALL ACTIONS FINISHED, TEMPORARY WORKING-DIRECTORY CAN BE DELETED
+ cd  -
+ [[ $delete_temporary_catalog = true ]]  &&  rm -rf $tempdir
